<?php
session_start();

include __DIR__ . '/safemysql.class.php';

define('CDN_HOST', 'https://cdn.miwix.ru');

if(isset($_REQUEST['checkDB'])) {
	$request_body = json_decode(file_get_contents('php://input'));
	$connection = @mysqli_connect($request_body->db_host, $request_body->db_user, $request_body->db_pass, $request_body->db_name);
	if (!$connection) {
		echo 'error';
	} else {
		$result = mysqli_query($connection, "SELECT COUNT(*) as tableCount FROM information_schema.tables WHERE table_schema = '".$request_body->db_name."'");
		$rows = mysqli_fetch_array($result, MYSQLI_ASSOC);
		if($rows['tableCount'] > 0) {
			echo 'isExists';
		} else {
			echo 'ok';
		}
		mysqli_close($connection);
	}
	exit;
}

function generateKey(){
	$chars = 'abdefhiknrstyzABDEFGHKNQRSTYZ23456789';
	$numChars = strlen($chars);
	$string = '';
	for ($i = 0; $i < 64; $i++) {
		$string .= substr($chars, rand(1, $numChars) - 1, 1);
	}
	return $string;
}

function init() {
	if (isset($_REQUEST['task_name'])) return run($_REQUEST['task_name']);
	if (!isset($_REQUEST['action'])) return false;
	
	$_SESSION['step'] = $_REQUEST['action'];
	
	if ($_REQUEST['action'] == 'home') {
		$_SESSION = [];
		header('Location: /__install/');
		exit;
	} elseif ($_REQUEST['action'] == 'step3' && !empty($_REQUEST['db_host']) && !empty($_REQUEST['db_user']) && isset($_REQUEST['db_pass'])) {
		$_SESSION['db_config'] = [
			'db_host' => $_REQUEST['db_host'],
			'db_name' => $_REQUEST['db_name'],
			'db_user' => $_REQUEST['db_user'],
			'db_pass' => $_REQUEST['db_pass']
		];
	} elseif ($_REQUEST['action'] == 'step4' && !empty($_REQUEST['admin_path']) && !empty($_REQUEST['admin_name']) && !empty($_REQUEST['admin_login']) && !empty($_REQUEST['admin_password']) && !empty($_REQUEST['admin_email'])) {
		$_SESSION['admin_config'] = [
			'admin_path' => $_REQUEST['admin_path'],
			'admin_name' => $_REQUEST['admin_name'],
			'admin_login' => $_REQUEST['admin_login'],
			'admin_password' => $_REQUEST['admin_password'],
			'admin_email' => $_REQUEST['admin_email']
		];
	}
}

function get_tasks() {
	return [
		'files_access' => 'Проверка доступа к файлам',
		'php' => 'Проверка версии PHP',
		'php_modules' => 'Проверка расширений PHP',
		'mysql' => 'Тестирование MySQL',
		'cdn_test' => 'Проверка сервера обновлений',
		'install_prepare_all' => 'Загрузка основных компонентов',
		'install_prepare_core' => 'Загрузка ядра MIWIX',
		'install_prepare_modules' => 'Загрузка модулей',
		'install_prepare_mysql' => 'Загрузка базы данных',
		'mysql_install' => 'Установка базы данных',
		'install_extract' => 'Распаковка файлов',
		'site_config' => 'Настройка параметров сайта',
		'clear_cache' => 'Завершение установки'
	];
}

function run($task_name) {
	if ($task_name === 'get_tasks') {
		echo get_tasks();
	} elseif (file_exists(__DIR__ . '/tasks/' . $task_name . '.php')) {
		include __DIR__ . '/tasks/' . $task_name . '.php';
	} else {
		echo 'error';
	}
	exit;
}
?>