<?php


$zip = new ZipArchive;

$root = __DIR__ . '/../../../';
$upload_dir = __DIR__ . '/../../../__tmp_upload/';

$zip->open($upload_dir . 'miwix_all.zip');
$zip->extractTo($root);
$zip->close();

recursiveRemoveDir($root . 'miwix-admin');

$zip->open($upload_dir . 'miwix_core.zip');
$zip->extractTo($root . 'miwix-admin/');
$zip->close();

recursiveRemoveDir($root . 'modules');

$modulesList = ['DynamicFields','AdminSearch','Gallery','Files','MarkdownEditor','Navigation','Pages','Themes','SendMail','Settings','System','Users','Login','Helper','DisableSite','Shop'];
foreach ($modulesList as $module) {

    $zip->open($upload_dir . $module);
    $zip->extractTo($root . 'modules/' . $module);
    $zip->close();
    checkTables($module);

}

$connection = @mysqli_connect($_SESSION['db_config']['db_host'], $_SESSION['db_config']['db_user'], $_SESSION['db_config']['db_pass'], $_SESSION['db_config']['db_name']);
if (!$connection) {
	echo 'error';
	die;
}

$privs = 'DynamicFields|AdminSearch|Gallery|Files|DropMail|DropModules|DropOrders|EditFiles|MarkdownEditor|Navigation|Pages|Themes|SendMail|Settings|System|Users|Login|Helper|DisableSite|Shop';

mysqli_query($connection, 'INSERT INTO `accesses` (`login`, `password`, `hash`, `ip`, `name`, `time`, `active`, `privilege`, `role`) VALUES'.
' (\''.trim($_SESSION['admin_config']['admin_login']).'\', \''.trim(password_hash(trim($_SESSION['admin_config']['admin_password']), PASSWORD_DEFAULT)).'\', \'0\', 0, \''.trim($_SESSION['admin_config']['admin_name']).'\', 0, 1, \''.$privs.'\', 1);');

mysqli_query($connection, "INSERT INTO `settings` (`name`, `val`, `placeholder`, `description`, `label`, `type`, `modules`) VALUES" .
"('access_mail', '". trim($_SESSION['admin_config']['admin_email']) ."', 'Введите Email: email@site.ru,email2@site.ru', 'Email для восстановления доступа в систему Miwix', '', 'text', 'settings');");

mysqli_query($connection, "INSERT INTO `settings` (`name`, `val`, `placeholder`, `description`, `label`, `type`, `modules`) VALUES" .
"('forms_mail', '". trim($_SESSION['admin_config']['admin_email']) ."', 'Введите Email: email@site.ru,email2@site.ru', 'Email для отправки форм с сайта', '', 'text', 'settings');");

mysqli_query($connection, "INSERT INTO `settings` (`name`, `val`, `placeholder`, `description`, `label`, `type`, `modules`) VALUES" .
"('secret_admin', '". trim($_SESSION['admin_config']['admin_path']) ."', 'Введите ключ', 'Ключ для изменения пути в систему администрирования', '', 'text', 'settings');");

mysqli_query($connection, "INSERT INTO `settings` (`name`, `val`, `placeholder`, `description`, `label`, `type`, `modules`) VALUES" .
"('subscribe', 1, 'Отправлять уведомления админу', 'Отправлять уведомления админу', 'Отправлять уведомления админу', 'checkbox', 'settings');");
	
mysqli_close($connection);

echo 'ok';

function checkTables($name)
{
    $root = __DIR__ . '/../../../';
    require_once 'HW_DatabaseChecker.php';

    if (!file_exists($_SERVER['DOCUMENT_ROOT'].'/modules/' . $name . '/DB.php')) {
        return;
    }


    $config = include_once $_SERVER['DOCUMENT_ROOT'].'/modules/' . $name . '/DB.php';

    $db_checker = new HW_DatabaseChecker(@mysqli_connect($_SESSION['db_config']['db_host'], $_SESSION['db_config']['db_user'], $_SESSION['db_config']['db_pass'], $_SESSION['db_config']['db_name']));
    $db_checker->initTable($config['tables']);
}

function recursiveRemoveDir($dir)
{
	if (!is_dir($dir)) {
		return;
	}
	$includes = new FilesystemIterator($dir);
	foreach ($includes as $include) {
		if (is_dir($include) && !is_link($include)) {
			recursiveRemoveDir($include);
		} else {
			unlink($include);
		}
	}
	rmdir($dir);
}

?>